<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 3.2//EN">
<HTML>
<HEAD>
	<META HTTP-EQUIV="CONTENT-TYPE" CONTENT="text/html; charset=utf-8">
	<TITLE>The transformation implementation in Kermeta</TITLE>
	<META NAME="GENERATOR" CONTENT="OpenOffice.org 2.2  (Linux)">
	<META NAME="CREATED" CONTENT="20070928;11000900">
	<META NAME="CHANGEDBY" CONTENT="Vincent Mahe">
	<META NAME="CHANGED" CONTENT="20070928;11000900">
</HEAD>
<BODY LANG="fr-FR" BGCOLOR="#ffffff" DIR="LTR">
<H1><FONT FACE="Nimbus Sans L"><FONT SIZE=5>The transformation
implementation in Kermeta</FONT></FONT></H1>
<H2><FONT FACE="Nimbus Sans L"><FONT SIZE=4><I>The imperative way
with Kermeta</I></FONT></FONT></H2>
<P>The transformation process we want to deploy is quite
straightforward as a single DFS can be used to build the
<I>RootElement</I>'s <I>CommonElement</I> list.</P>
<H3><FONT FACE="Nimbus Sans L">Software architecture</FONT></H3>
<P>Kermeta being strongly object oriented, it allows to “think”
and build any transformation on an OO architecture, using (almost)
all features one can use with any OO language.</P>
<P>The “Tree2List” transformation is composed 3 classes :</P>
<UL>
	<LI><P>the “Main” class contains the <I>main()</I> method which
	is the starting point</P>
	<LI><P>the “Tree2List” class contains the implementation of the
	transformation algorithm</P>
	<LI><P>the “ResourceHandler” class factorizes the load/save of a
	model instance</P>
</UL>
<H3><FONT FACE="Nimbus Sans L">The implementation</FONT></H3>
<P>The process is quite simple and follows a standard Kermeta
transformation process :</P>
<OL>
	<LI><P>“load” the model into a Kermeta resource</P>
	<LI><P>retrieve the tree's root (<I>MMTree.Node</I>)</P>
	<LI><P>launch the transformation on the node</P>
	<LI><P>retrieve the list root (<I>MMElementList.RootElement</I>)</P>
	<LI><P>“save” the resource into a XMI file</P>
</OL>
<P>The most interesting part is the algorithm contained in the
Tree2List class. This class contains 4 attributes :</P>
<UL>
	<LI><P>the tree's root node</P>
	<LI><P>3 ordered sets of <I>MMElementList.CommonElement
	</I>corresponding to the big, medium and small sized leaves
	encountered during the transformation</P>
</UL>
<P>The algorithm is a basic DFS of the tree. For each node (starting
by the tree's root), we explore its (ordered) list of children and
test their type :</P>
<UL>
	<LI><P>if it is a node, make a recursive call</P>
	<LI><P>if not (hence, a leaf), 
	</P>
	<UL>
		<LI><P>create a <I>MMElementList.CommonElement</I></P>
		<LI><P>copy the leaf's name attribute value into the
		<I>CommonElement</I>'s one</P>
		<LI><P>test the leaf's size attribute and add the created
		<I>CommonElement</I> into one of the 3 lists according to the size</P>
	</UL>
	<LI><P>once the DFS has ended, we have completed the 3 ordered lists
	of <I>CommonElement</I>. We concatenate them into one (big then
	medium then small) and return it</P>
</UL>
<H2><FONT FACE="Nimbus Sans L"><FONT SIZE=4>The launcher</FONT></FONT></H2>
<P>The launcher configuration is pretty common as both meta models
have been created with the EMF Ecore plugin. However it is <B>imperative</B>
both meta models' URI match their path as stated in the Kermeta FAQ :
<A HREF="http://www.kermeta.org/documents/faq/resource_load_exception">http://www.kermeta.org/documents/faq/resource_load_exception</A></P>
<P>As a sidenote, the &laquo;&nbsp;Tree&nbsp;&raquo; model instance
matching the example in this paper is available in the
&laquo;&nbsp;modelinstances&nbsp;&raquo; directory of the
&laquo;&nbsp;fr.cs.leplessis.example.tree&nbsp;&raquo; project. The
resulting &laquo;&nbsp;List&nbsp;&raquo; model instance should be
located in the &laquo;&nbsp;modelinstances&nbsp;&raquo; directory of
the &laquo;&nbsp;fr.cs.leplessis.example.list&nbsp;&raquo; project.</P>
</BODY>
</HTML>